#include <vcl.h>
#include <windows.h>
#include <stdlib.h>
#include <math.h>
#include "drawing.h"
#pragma argsused

//---------------------------------------------------------------------------
double myfrac(double x)
{
    double result;

    result = x-floor(x);
    return result;
}
//---------------------------------------------------------------------------

/*************************************************************************
      API
*************************************************************************/
void setpixelAPI(HDC hDC, int x, int y, COLORREF color,double brightness)
{
COLORREF px=GetPixel(hDC,x,y);
SetPixel(hDC,x,y,
RGB(GetRValue(px)*(1-brightness)+GetRValue(color)*brightness,
    GetGValue(px)*(1-brightness)+GetGValue(color)*brightness,
    GetBValue(px)*(1-brightness)+GetBValue(color)*brightness)
   );
}
//---------------------------------------------------------------------------

/*************************************************************************
      API
*************************************************************************/
void setpixel(TCanvas *Canvas, int x, int y, COLORREF color,double brightness)
{
COLORREF px=Canvas->Pixels[x][y];
Canvas->Pixels[x][y]=
RGB(GetRValue(px)*(1-brightness)+GetRValue(color)*brightness,
    GetGValue(px)*(1-brightness)+GetGValue(color)*brightness,
    GetBValue(px)*(1-brightness)+GetBValue(color)*brightness);
}
//---------------------------------------------------------------------------

/*************************************************************************
      
.
*************************************************************************/
//---------------------------------------------------------------------------
void drawlineAPI(HDC hDC, double x1, double y1, double x2, double y2,COLORREF color)
{
    double grad;
    double xd;
    double yd;
    double length;
    double xm;
    double ym;
    double xgap;
    double ygap;
    double xend;
    double yend;
    double xf;
    double yf;
    double brightness1;
    double brightness2;
    int x;
    int y;
    int ix1;
    int ix2;
    int iy1;
    int iy2;
    bool wasexchange;
    int tmpint;
    double tmpreal;

    xd = x2-x1;
    yd = y2-y1;
    if( xd==0&&yd==0 )
    {
        return;
    }
    if( fabs(xd)>fabs(yd) )
    {
        wasexchange = false;
    }
    else
    {
        wasexchange = true;
        tmpreal = x1;
        x1 = y1;
        y1 = tmpreal;
        tmpreal = x2;
        x2 = y2;
        y2 = tmpreal;
        tmpreal = xd;
        xd = yd;
        yd = tmpreal;
    }
    if( x1>x2 )
    {
        tmpreal = x1;
        x1 = x2;
        x2 = tmpreal;
        tmpreal = y1;
        y1 = y2;
        y2 = tmpreal;
        xd = x2-x1;
        yd = y2-y1;
    }
    grad = yd/xd;
    xend = floor(x1+0.5);
    yend = y1+grad*(xend-x1);
    xgap = 1-myfrac(x1+0.5);
    ix1 = floor(x1+0.5);
    iy1 = floor(yend);
    brightness1 = (1-myfrac(yend))*xgap;
    brightness2 = myfrac(yend)*xgap;
    if( wasexchange )
    {
        setpixelAPI(hDC,iy1,   ix1, color, brightness1);
        setpixelAPI(hDC,iy1+1, ix1, color, brightness2);
    }
    else
    {
        setpixelAPI(hDC,ix1, iy1,   color, brightness1);
        setpixelAPI(hDC,ix1, iy1+1, color, brightness2);
    }
    yf = yend+grad;
    xend = floor(x2+0.5);
    yend = y2+grad*(xend-x2);
    xgap = 1-myfrac(x2-0.5);
    ix2 = floor(x2+0.5);
    iy2 = floor(yend);
    brightness1 = (1-myfrac(yend))*xgap;
    brightness2 = myfrac(yend)*xgap;
    if( wasexchange )
    {
        setpixelAPI(hDC,iy2,   ix2, color, brightness1);
        setpixelAPI(hDC,iy2+1, ix2, color, brightness2);
    }
    else
    {
        setpixelAPI(hDC,ix2, iy2,   color, brightness1);
        setpixelAPI(hDC,ix2, iy2+1, color, brightness2);
    }
    for(x = ix1+1; x <= ix2-1; x++)
    {
        brightness1 = 1-myfrac(yf);
        brightness2 = myfrac(yf);
        if( wasexchange )
        {
            setpixelAPI(hDC,floor(yf),   x, color, brightness1);
            setpixelAPI(hDC,floor(yf)+1, x, color, brightness2);
        }
        else
        {
            setpixelAPI(hDC,x, floor(yf),   color, brightness1);
            setpixelAPI(hDC,x, floor(yf)+1, color, brightness2);
        }
        yf = yf+grad;
    }
}
//---------------------------------------------------------------------------
/*************************************************************************
      
.
*************************************************************************/
void drawcircleAPI(HDC hDC,int cx, int cy,int r, COLORREF color)
{
    int x;
    int y;
    double t;
    double d;
    int j;
    int kx;
    int ky;
    int lastx;

    x = r;
    lastx = r;
    y = 0;
    t = 0;
    for(j = 0; j <= 3; j++)
    {
        kx = j%2*2-1;
        ky = j/2%2*2-1;
        setpixelAPI(hDC,kx*x+cx, ky*y+cy, color, 1);
        setpixelAPI(hDC,kx*y+cx, ky*x+cy, color, 1);
    }
    while(x>y)
    {
        y = y+1;
        d = ceil(sqrt(r*r-y*y))-sqrt(r*r-y*y);
        if( d<t )
        {
            x = x-1;
        }
        if( x<y )
        {
            break;
        }
        if( x==y&&lastx==x )
        {
            break;
        }
        for(j = 0; j <= 3; j++)
        {
            kx = j%2*2-1;
            ky = j/2%2*2-1;
            setpixelAPI(hDC,kx*x+cx, ky*y+cy, color, 1-d);
            setpixelAPI(hDC,kx*y+cx, ky*x+cy, color, 1-d);
            if( x-1>=y )
            {
                setpixelAPI(hDC,kx*(x-1)+cx, ky*y+cy,     color, d);
                setpixelAPI(hDC,kx*y+cx,     ky*(x-1)+cy, color, d);
            }
        }
        t = d;
        lastx = x;
    }
}
//---------------------------------------------------------------------------

/*************************************************************************
      
.
*************************************************************************/
//---------------------------------------------------------------------------
void drawlineVCL(TCanvas *Canvas, double x1, double y1, double x2, double y2,COLORREF color)
{
    double grad;
    double xd;
    double yd;
    double length;
    double xm;
    double ym;
    double xgap;
    double ygap;
    double xend;
    double yend;
    double xf;
    double yf;
    double brightness1;
    double brightness2;
    int x;
    int y;
    int ix1;
    int ix2;
    int iy1;
    int iy2;
    bool wasexchange;
    int tmpint;
    double tmpreal;

    xd = x2-x1;
    yd = y2-y1;
    if( xd==0&&yd==0 )
    {
        return;
    }
    if( fabs(xd)>fabs(yd) )
    {
        wasexchange = false;
    }
    else
    {
        wasexchange = true;
        tmpreal = x1;
        x1 = y1;
        y1 = tmpreal;
        tmpreal = x2;
        x2 = y2;
        y2 = tmpreal;
        tmpreal = xd;
        xd = yd;
        yd = tmpreal;
    }
    if( x1>x2 )
    {
        tmpreal = x1;
        x1 = x2;
        x2 = tmpreal;
        tmpreal = y1;
        y1 = y2;
        y2 = tmpreal;
        xd = x2-x1;
        yd = y2-y1;
    }
    grad = yd/xd;
    xend = floor(x1+0.5);
    yend = y1+grad*(xend-x1);
    xgap = 1-myfrac(x1+0.5);
    ix1 = floor(x1+0.5);
    iy1 = floor(yend);
    brightness1 = (1-myfrac(yend))*xgap;
    brightness2 = myfrac(yend)*xgap;
    if( wasexchange )
    {
        setpixel(Canvas,iy1,   ix1, color, brightness1);
        setpixel(Canvas,iy1+1, ix1, color, brightness2);
    }
    else
    {
        setpixel(Canvas,ix1, iy1,   color, brightness1);
        setpixel(Canvas,ix1, iy1+1, color, brightness2);
    }
    yf = yend+grad;
    xend = floor(x2+0.5);
    yend = y2+grad*(xend-x2);
    xgap = 1-myfrac(x2-0.5);
    ix2 = floor(x2+0.5);
    iy2 = floor(yend);
    brightness1 = (1-myfrac(yend))*xgap;
    brightness2 = myfrac(yend)*xgap;
    if( wasexchange )
    {
        setpixel(Canvas,iy2,   ix2, color, brightness1);
        setpixel(Canvas,iy2+1, ix2, color, brightness2);
    }
    else
    {
        setpixel(Canvas,ix2, iy2,   color, brightness1);
        setpixel(Canvas,ix2, iy2+1, color, brightness2);
    }
    for(x = ix1+1; x <= ix2-1; x++)
    {
        brightness1 = 1-myfrac(yf);
        brightness2 = myfrac(yf);
        if( wasexchange )
        {
            setpixel(Canvas,floor(yf),   x, color, brightness1);
            setpixel(Canvas,floor(yf)+1, x, color, brightness2);
        }
        else
        {
            setpixel(Canvas,x, floor(yf),   color, brightness1);
            setpixel(Canvas,x, floor(yf)+1, color, brightness2);
        }
        yf = yf+grad;
    }
}
//---------------------------------------------------------------------------
/*************************************************************************
      
.
*************************************************************************/
void drawcircleVCL(TCanvas *Canvas,int cx, int cy,int r, COLORREF color)
{
    int x;
    int y;
    double t;
    double d;
    int j;
    int kx;
    int ky;
    int lastx;

    x = r;
    lastx = r;
    y = 0;
    t = 0;
    for(j = 0; j <= 3; j++)
    {
        kx = j%2*2-1;
        ky = j/2%2*2-1;
        setpixel(Canvas,kx*x+cx, ky*y+cy, color, 1);
        setpixel(Canvas,kx*y+cx, ky*x+cy, color, 1);
    }
    while(x>y)
    {
        y = y+1;
        d = ceil(sqrt(r*r-y*y))-sqrt(r*r-y*y);
        if( d<t )
        {
            x = x-1;
        }
        if( x<y )
        {
            break;
        }
        if( x==y&&lastx==x )
        {
            break;
        }
        for(j = 0; j <= 3; j++)
        {
            kx = j%2*2-1;
            ky = j/2%2*2-1;
            setpixel(Canvas,kx*x+cx, ky*y+cy, color, 1-d);
            setpixel(Canvas,kx*y+cx, ky*x+cy, color, 1-d);
            if( x-1>=y )
            {
                setpixel(Canvas,kx*(x-1)+cx, ky*y+cy,     color, d);
                setpixel(Canvas,kx*y+cx,     ky*(x-1)+cy, color, d);
            }
        }
        t = d;
        lastx = x;
    }
}
//---------------------------------------------------------------------------

